'''
    PyBB - Auto link processor Module

    Copyright (c) 2003-2004 Gang Seong Lee <gslee@mail.kw.ac.kr>
    All rights reserved, see COPYING for details.
'''

import re

linkPattern = re.compile('([\w\-_\.]+@[\w\-_]+\.[\w\-_\.]+)|(http://[\w|/|.|=|\-|?|&|_|:]+)', re.I)
def linkProcessor(text):
    def linkReplace(match):
        link = match.group()
        pos = match.start()
        spos = max(pos-15, 0)
        if text[spos:pos].lower().find('href=') >= 0 or text[spos:pos].lower().find('src=') >= 0:
            return link
        if link.lower().startswith('http'):
            return '<a href="%s" target="_blank">%s</a>' % (link, link)
        return '<a href="mailto:%s">%s</a>' % (link, link)
    return linkPattern.sub(linkReplace, text)
